Whamcloud - gitweb
LU-14362 tests: sanity-flr to prepare stuff before checks
[fs/lustre-release.git] / lustre / tests / sanity-flr.sh
index 2631eca..f9bbf7f 100644 (file)
@@ -5,36 +5,45 @@
 set -e
 set +o posix
 
-SRCDIR=$(dirname $0)
-export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/../utils:$PATH:/sbin
 
 ONLY=${ONLY:-"$*"}
-# Bug number for skipped test:    LU-11381
-ALWAYS_EXCEPT="$SANITY_FLR_EXCEPT 201"
-# UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
-LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
+LUSTRE=${LUSTRE:-$(dirname $0)/..}
 . $LUSTRE/tests/test-framework.sh
 init_test_env $@
-. ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
 
-[[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.10.56) ]] ||
-       { skip "Need MDS version at least 2.10.56"; exit 0; }
+ALWAYS_EXCEPT="$SANITY_FLR_EXCEPT "
+# Bug number for skipped test:    LU-11381
+ALWAYS_EXCEPT+="                  201 "
+# UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
-[ $UID -eq 0 -a $RUNAS_ID -eq 0 ] &&
-       error "\$RUNAS_ID set to 0, but \$UID is also 0!"
-check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS
+# skip all tests for PPC until we can get sanity-pfl to pass
+if [[ $(uname -m) = ppc64 ]]; then
+       skip "Skip FLR testing for PPC clients"
+fi
 
-check_and_setup_lustre
-DIR=${DIR:-$MOUNT}
-assert_DIR
+if [[ "$ost1_FSTYPE" == "zfs" ]]; then
+       # bug #:        LU-1941
+       ALWAYS_EXCEPT+="49a"
+fi
 
 build_test_filter
 
+[[ "$MDS1_VERSION" -ge $(version_code 2.10.56) ]] ||
+       skip "Need MDS version at least 2.10.56"
+
+check_and_setup_lustre
+DIR=${DIR:-$MOUNT}
 assert_DIR
 rm -rf $DIR/[Rdfs][0-9]*
 
+[ $UID -eq 0 -a $RUNAS_ID -eq 0 ] &&
+       error "\$RUNAS_ID set to 0, but \$UID is also 0!"
+
+check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS
+
+
 # global array to store mirror IDs
 declare -a mirror_array
 get_mirror_ids() {
@@ -274,6 +283,16 @@ verify_comp_attrs() {
        verify_comp_attr_with_parent pool $tf $comp_id
 }
 
+verify_flr_state()
+{
+       local tf=$1
+       local expected_state=$2
+
+       local state=$($LFS getstripe -v $tf | awk '/lcm_flags/{ print $2 }')
+       [ $expected_state = $state ] ||
+               error "expected: $expected_state, actual $state"
+}
+
 # command line test cases
 test_0a() {
        local td=$DIR/$tdir
@@ -381,6 +400,15 @@ test_0b() {
        verify_comp_attr stripe-count $tf ${ids[5]} $OSTCOUNT
        verify_comp_attr_with_parent pool $tf ${ids[5]}
 
+       if [ $MDS1_VERSION -ge $(version_code 2.12.55) ]; then
+               # LU-11022 - remove mirror by pool name
+               local=cnt cnt=$($LFS getstripe $tf | grep archive | wc -l)
+               [ "$cnt" != "1" ] && error "unexpected mirror count $cnt"
+               $LFS mirror delete --pool archive $tf || error "delete mirror"
+               cnt=$($LFS getstripe $tf | grep archive | wc -l)
+               [ "$cnt" != "0" ] && error "mirror count after removal: $cnt"
+       fi
+
        # destroy OST pool
        destroy_test_pools
 }
@@ -585,11 +613,12 @@ test_0f() {
                error "create mirrored file $tf failed"
 
        # extend the mirrored file with composite layout mirrors
-       $mirror_cmd -N2 -E 4M -c 2 -p flash -i 1 -o 1,3 -E eof -S 4M \
+       $mirror_cmd -N -p archive \
+                   -N2 -E 4M -c 2 -p flash -i 1 -o 1,3 -E eof -S 4M \
                    -N -c -1 -p none \
                    -N3 -E 512M -S 16M -p archive -E -1 -i -1 -c -1 $tf ||
                error "extend mirrored file $tf failed"
-       verify_mirror_count $tf 7
+       verify_mirror_count $tf 8
        ids=($($LFS getstripe $tf | awk '/lcme_id/{print $2}' | tr '\n' ' '))
 
        # verify component ${ids[0]}
@@ -604,8 +633,14 @@ test_0f() {
        verify_comp_attr pool $tf ${ids[1]} ssd
        verify_comp_extent $tf ${ids[1]} 33554432 EOF
 
-       # verify components ${ids[2]} and ${ids[4]}
-       for i in 2 4; do
+       # verify component ${ids[2]}
+       verify_comp_attr stripe-size $tf ${ids[0]} 16777216
+       verify_comp_attr_with_default stripe-count $tf ${ids[2]}
+       verify_comp_attr pool $tf ${ids[2]} archive
+       verify_comp_extent $tf ${ids[2]} 0 EOF
+
+       # verify components ${ids[3]} and ${ids[5]}
+       for i in 3 5; do
                verify_comp_attr_with_default stripe-size $tf ${ids[$i]}
                verify_comp_attr stripe-count $tf ${ids[$i]} 2
                verify_comp_attr stripe-index $tf ${ids[$i]} 1
@@ -613,30 +648,30 @@ test_0f() {
                verify_comp_extent $tf ${ids[$i]} 0 4194304
        done
 
-       # verify components ${ids[3]} and ${ids[5]}
-       for i in 3 5; do
+       # verify components ${ids[4]} and ${ids[6]}
+       for i in 4 6; do
                verify_comp_attr stripe-size $tf ${ids[$i]} 4194304
                verify_comp_attr stripe-count $tf ${ids[$i]} 2
                verify_comp_attr pool $tf ${ids[$i]} flash
                verify_comp_extent $tf ${ids[$i]} 4194304 EOF
        done
 
-       # verify component ${ids[6]}
-       verify_comp_attr stripe-size $tf ${ids[6]} 4194304
-       verify_comp_attr stripe-count $tf ${ids[6]} $OSTCOUNT
-       verify_comp_attr_with_parent pool $tf ${ids[6]}
-       verify_comp_extent $tf ${ids[6]} 0 EOF
+       # verify component ${ids[7]}
+       verify_comp_attr stripe-size $tf ${ids[7]} 4194304
+       verify_comp_attr stripe-count $tf ${ids[7]} $OSTCOUNT
+       verify_comp_attr_with_parent pool $tf ${ids[7]}
+       verify_comp_extent $tf ${ids[7]} 0 EOF
 
-       # verify components ${ids[7]}, ${ids[9]} and ${ids[11]}
-       for i in 7 9 11; do
+       # verify components ${ids[8]}, ${ids[10]} and ${ids[12]}
+       for i in 8 10 12; do
                verify_comp_attr stripe-size $tf ${ids[$i]} 16777216
                verify_comp_attr stripe-count $tf ${ids[$i]} $OSTCOUNT
                verify_comp_attr pool $tf ${ids[$i]} archive
                verify_comp_extent $tf ${ids[$i]} 0 536870912
        done
 
-       # verify components ${ids[8]}, ${ids[10]} and ${ids[12]}
-       for i in 8 10 12; do
+       # verify components ${ids[9]}, ${ids[11]} and ${ids[13]}
+       for i in 9 11 13; do
                verify_comp_attr stripe-size $tf ${ids[$i]} 16777216
                verify_comp_attr stripe-count $tf ${ids[$i]} -1
                verify_comp_attr pool $tf ${ids[$i]} archive
@@ -667,13 +702,16 @@ test_0g() {
        cat $tf &> /dev/null || error "error reading file '$tf'"
 
        # verify that the data was provided by OST1 where mirror 1 resides
-       local nr_read=$($LCTL get_param -n osc.$FSNAME-OST0000-osc-ffff*.stats |
+       local nr_read=$($LCTL get_param -n osc.$FSNAME-OST0000-osc-[-0-9a-f]*.stats |
                        awk '/ost_read/{print $2}')
        [ -n "$nr_read" ] || error "read was not provided by OST1"
 }
 run_test 0g "lfs mirror create flags support"
 
 test_0h() {
+       [ $MDS1_VERSION -lt $(version_code 2.11.57) ] &&
+               skip "Need MDS version at least 2.11.57"
+
        local td=$DIR/$tdir
        local tf=$td/$tfile
        local ids
@@ -709,9 +747,56 @@ test_0h() {
                error "error setting flag prefer"
 
        verify_comp_attr lcme_flags $tf 0x20003 prefer
+
+       $LFS setstripe --comp-set -I 0x20003 --comp-flags=^prefer $tf ||
+               error "error clearing prefer flag from component 0x20003"
+
+       # MDS disallows setting stale flag on the last non-stale mirror
+       [[ "$MDS1_VERSION" -ge $(version_code 2.12.57) ]] || return 0
+
+       cp /etc/hosts $tf || error "error writing file '$tf'"
+
+       verify_comp_attr lcme_flags $tf 0x10002 prefer
+       verify_comp_attr lcme_flags $tf 0x20003 stale
+       verify_comp_attr lcme_flags $tf 0x30004 stale
+
+       ! $LFS setstripe --comp-set -I 0x10002 --comp-flags=^prefer,stale $tf \
+               > /dev/null 2>&1 ||
+               error "setting stale flag on component 0x10002 should fail"
+
+       $LFS mirror resync $tf || error "error resync-ing file '$tf'"
+
+       $LFS setstripe --comp-set -I 0x10001 --comp-flags=stale $tf ||
+               error "error setting stale flag on component 0x10001"
+       $LFS setstripe --comp-set -I 0x20003 --comp-flags=stale $tf ||
+               error "error setting stale flag on component 0x20003"
+
+       ! $LFS setstripe --comp-set -I 0x30004 --comp-flags=stale $tf \
+               > /dev/null 2>&1 ||
+               error "setting stale flag on component 0x30004 should fail"
+
+       $LFS mirror resync $tf || error "error resync-ing file '$tf'"
 }
 run_test 0h "set, clear and test flags for FLR files"
 
+test_0j() {
+       $LFS mirror create -N2 $DIR/$tfile || error "create $DIR/$tfile failed"
+
+       cp /etc/hosts $DIR/$tfile || error "write to $DIR/$tfile failed"
+       $LFS mirror resync $DIR/$tfile || error "resync $DIR/$tfile failed"
+       cmp /etc/hosts $DIR/$tfile || error "cmp with /etc/hosts failed"
+
+       $LFS mirror read -N2 -o $TMP/$tfile $DIR/$tfile || "read mirror failed"
+       stack_trap "rm -f $TMP/$tfile"
+       cmp $TMP/$tfile $DIR/$tfile || error "cmp with $TMP/$tfile failed"
+       $LFS mirror write -N2 -i /etc/passwd $DIR/$tfile || "write failed"
+       $LFS setstripe --comp-set -I 65537 --comp-flags=stale $DIR/$tfile ||
+               error "set component 1 stale failed"
+       $LFS mirror resync $DIR/$tfile || error "resync $DIR/$tfile failed"
+       cmp /etc/passwd $DIR/$tfile || error "cmp with /etc/passwd failed"
+}
+run_test 0j "test lfs mirror read/write commands"
+
 test_1() {
        local tf=$DIR/$tfile
        local mirror_count=16 # LUSTRE_MIRROR_COUNT_MAX
@@ -895,7 +980,7 @@ get_osc_lock_count() {
                local osc_name
                local count
 
-               osc_name=${FSNAME}-OST$(printf "%04x" $((idx-1)))-osc-'ffff*'
+               osc_name=${FSNAME}-OST$(printf "%04x" $((idx-1)))-osc-'[-0-9a-f]*'
                count=$($LCTL get_param -n ldlm.namespaces.$osc_name.lock_count)
                lock_count=$((lock_count + count))
        done
@@ -1000,7 +1085,7 @@ test_32() {
 }
 run_test 32 "data should be mirrored to newly created mirror"
 
-test_33() {
+test_33a() {
        [[ $OSTCOUNT -lt 2 ]] && skip "need >= 2 OSTs" && return
 
        rm -f $DIR/$tfile $DIR/$tfile-2
@@ -1060,10 +1145,8 @@ test_33() {
        start_osts 1
 
        # read file again with ost2 failed
-       $LCTL set_param ldlm.namespaces.lustre-*-osc-ffff*.lru_size=clear
-
-       fail ost2 &
-       sleep 1
+       stop_osts 2
+       drop_client_cache
 
        # check size, glimpse should work
        $CHECKSTAT -t file -s $fsize $DIR/$tfile ||
@@ -1074,9 +1157,116 @@ test_33() {
        [[ "$rs" == "ost1" ]] ||
                error "file content error: expected: \"ost1\", actual: \"$rs\""
 
-       wait_osc_import_state client ost2 FULL
+       start_osts 2
+}
+run_test 33a "read can choose available mirror to read"
+
+test_33b() {
+       [[ $OSTCOUNT -lt 2 ]] && skip "need >= 2 OSTs" && return
+
+       rm -f $DIR/$tfile
+
+       stack_trap "rm -f $DIR/$tfile" EXIT
+
+       # create a file with two mirrors on OST0000 and OST0001
+       $LFS setstripe -N -Eeof -o0 -N -Eeof -o1 $DIR/$tfile
+
+       # make sure that $tfile has two mirrors
+       [ $($LFS getstripe -N $DIR/$tfile) -eq 2 ] ||
+               { $LFS getstripe $DIR/$tfile; error "expected count 2"; }
+
+       # write 50M
+       dd if=/dev/urandom of=$DIR/$tfile bs=2M count=25 ||
+               error "write failed for $DIR/$tfile"
+       $LFS mirror resync $DIR/$tfile || error "resync failed for $DIR/$tfile"
+       verify_flr_state $DIR/$tfile "ro"
+       drop_client_cache
+
+       ls -l $DIR/$tfile
+
+       # read file - all OSTs are available
+       echo "reading file (data can be provided by any ost)... "
+       local t1=$SECONDS
+       time cat $DIR/$tfile > /dev/null || error "read all"
+       local t2=$SECONDS
+       ra=$((t2 - t1))
+
+       # read file again with ost1 {OST0000} failed
+       stop_osts 1
+       drop_client_cache
+       echo "reading file (data should be provided by ost2)..."
+       t1=$SECONDS
+       time cat $DIR/$tfile > /dev/null || error "read ost2"
+       t2=$SECONDS
+       r1=$((t2 - t1))
+
+       # remount ost1
+       start_osts 1
+
+       # read file again with ost2 {OST0001} failed
+       stop_osts 2
+       drop_client_cache
+
+       echo "reading file (data should be provided by ost1)..."
+       t1=$SECONDS
+       time cat $DIR/$tfile > /dev/null || error "read ost1"
+       t2=$SECONDS
+       r2=$((t2 - t1))
+
+       # remount ost2
+       start_osts 2
+
+       [ $((r1 * 100)) -gt $((ra * 105)) -a $r1 -gt $((ra + 2)) ] &&
+               error "read mirror too slow without ost1, from $ra to $r1"
+       [ $((r2 * 100)) -gt $((ra * 105)) -a $r2 -gt $((ra + 2)) ] &&
+               error "read mirror too slow without ost2, from $ra to $r2"
+
+       wait_osc_import_ready client ost2
+}
+run_test 33b "avoid reading from unhealthy mirror"
+
+test_33c() {
+       [[ $OSTCOUNT -lt 3 ]] && skip "need >= 3 OSTs" && return
+
+       rm -f $DIR/$tfile
+
+       stack_trap "rm -f $DIR/$tfile" EXIT
+
+       # create a file with two mirrors
+       # mirror1: {OST0000, OST0001}
+       # mirror2: {OST0001, OST0002}
+       $LFS setstripe -N -Eeof -c2 -o0,1 -N -Eeof -c2 -o1,2 $DIR/$tfile
+
+       # make sure that $tfile has two mirrors
+       [ $($LFS getstripe -N $DIR/$tfile) -eq 2 ] ||
+               { $LFS getstripe $DIR/$tfile; error "expected count 2"; }
+
+       # write 50M
+       dd if=/dev/urandom of=$DIR/$tfile bs=2M count=25 ||
+               error "write failed for $DIR/$tfile"
+       $LFS mirror resync $DIR/$tfile || error "resync failed for $DIR/$tfile"
+       verify_flr_state $DIR/$tfile "ro"
+       drop_client_cache
+
+       ls -l $DIR/$tfile
+
+       # read file - all OSTs are available
+       echo "reading file (data can be provided by any ost)... "
+       time cat $DIR/$tfile > /dev/null || error "read all"
+
+       # read file again with ost2 (OST0001) failed
+       stop_osts 2
+       drop_client_cache
+
+       echo "reading file (data should be provided by ost1 and ost3)..."
+       time cat $DIR/$tfile > /dev/null || error "read ost1 & ost3"
+
+       # remount ost2
+       start_osts 2
+
+       wait_osc_import_ready client ost2
 }
-run_test 33 "read can choose available mirror to read"
+run_test 33c "keep reading among unhealthy mirrors"
 
 test_34a() {
        [[ $OSTCOUNT -lt 4 ]] && skip "need >= 4 OSTs" && return
@@ -1270,6 +1460,9 @@ create_files_37() {
 
 test_37()
 {
+       [ $MDS1_VERSION -lt $(version_code 2.11.57) ] &&
+               skip "Need MDS version at least 2.11.57"
+
        local tf=$DIR/$tfile
        local tf2=$DIR/$tfile-2
        local tf3=$DIR/$tfile-3
@@ -1320,37 +1513,21 @@ test_37()
 
        local osts=$(comma_list $(osts_nodes))
 
-       # define OBD_FAIL_OST_SKIP_LV_CHECK     0x241
-       do_nodes $osts lctl set_param fail_loc=0x241
-
-       mirror_io copy -i ${mirror_array[0]} \
-               -t $(echo ${mirror_array[@]:1} | tr ' ' ',') $tf ||
-                       error "mirror copy error"
-
-       do_nodes $osts lctl set_param fail_loc=0
+       $LFS mirror copy -i ${mirror_array[0]} -o-1 $tf ||
+               error "mirror copy error"
 
        # verify copying is successful by checking checksums
        remount_client $MOUNT
        for i in ${mirror_array[@]}; do
                sum=$($LFS mirror read -N $i $tf | md5sum)
                [ "$sum" = "${checksums[1]}" ] ||
-                       error "$i: mismatch checksum after copy"
+                       error "$i: mismatch checksum after copy \'$sum\'"
        done
 
        rm -f $tf
 }
 run_test 37 "mirror I/O API verification"
 
-verify_flr_state()
-{
-       local tf=$1
-       local expected_state=$2
-
-       local state=$($LFS getstripe -v $tf | awk '/lcm_flags/{ print $2 }')
-       [ $expected_state = $state ] ||
-               error "expected: $expected_state, actual $state"
-}
-
 test_38() {
        local tf=$DIR/$tfile
        local ref=$DIR/${tfile}-ref
@@ -1776,6 +1953,10 @@ test_44() {
 
        verify_flr_state $tf "wp"
 
+       # disallow destroying the last non-stale mirror
+       ! $LFS mirror delete --mirror-id 1 $tf > /dev/null 2>&1 ||
+               error "destroying mirror 1 should fail"
+
        # synchronize all mirrors of the file
        $LFS mirror resync $tf || error "mirror resync $tf failed"
 
@@ -1801,8 +1982,17 @@ test_44() {
        verify_mirror_count $tf 2
        verify_mirror_count $tf.mirror~2 1
 
+       $LFS setstripe --comp-set -I 0x30008 --comp-flags=stale $tf ||
+               error "setting stale flag on component 0x30008 failed"
+
+       # disallow destroying the last non-stale mirror
+       ! $LFS mirror split --mirror-id 4 -d $tf > /dev/null 2>&1 ||
+               error "destroying mirror 4 should fail"
+
+       $LFS mirror resync $tf || error "resynchronizing $tf failed"
+
        $LFS mirror split --mirror-id 3 -d $tf ||
-               error "split and delte mirror 3 failed"
+               error "destroying mirror 3 failed"
        verify_mirror_count $tf 1
 
        # verify splitted file contains the same content as the orig file does
@@ -1813,7 +2003,7 @@ test_44() {
 run_test 44 "lfs mirror split check"
 
 test_45() {
-       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs" && return
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs"
 
        local file=$DIR/$tdir/$tfile
        local dir=$DIR/$tdir/$dir
@@ -1825,16 +2015,14 @@ test_45() {
                -N -E3m -S1m -Eeof -N -E8m -Eeof $file ||
                        error "Create $file failed"
 
-       echo "getstripe --yaml $file"
-       $LFS getstripe --yaml $file > $temp || error "getstripe $file failed"
-       echo "setstripe --yaml=$temp $file.2"
-       $LFS setstripe --yaml=$temp $file.2 || error "setstripe $file.2 failed"
+       verify_yaml_layout $file $file.copy $temp "1. FLR file"
+       rm -f $file $file.copy
 
-       echo "compare layout"
-       local layout1=$(get_layout_param $file)
-       local layout2=$(get_layout_param $file.2)
-       [ "$layout1" == "$layout2" ] ||
-               error "FLR file $file/$file.2 layouts are not equal"
+       $LFS setstripe -N -E1m -S1m -c2 -o0,1 -E2m -Eeof -N -E4m -Eeof \
+               -N -E3m -S1m -Eeof -N -E8m --flags=prefer -Eeof $file ||
+                       error "Create $file failed"
+
+       verify_yaml_layout $file $file.copy $temp "2. FLR file with flags"
 }
 run_test 45 "Verify setstripe/getstripe with YAML with FLR file"
 
@@ -1878,6 +2066,7 @@ test_46() {
 
        ########################### 3. FLR file #############################
        echo "  ** 3. FLR file"
+       rm -f $file
        $LFS setstripe -N -E1m -S 1M -c2 -o0,1 -E4m -c1 -Eeof -N -E16m -Eeof \
                $file || error "3. Create FLR $file failed"
 
@@ -1906,6 +2095,38 @@ test_46() {
                error "6. setstripe FLR $dir failed"
 
        verify_46 $dir $dir.copy "6. FLR dir"
+
+       ########################### 7. SEL file ##############################
+       echo "  ** 7. SEL file"
+       rm -f $file
+       $LFS setstripe -E256M -S 1M -c2 -o0,1 -z 64M -E-1 -o1,0 -z 128M \
+               $file || error "Create $file failed"
+
+       rm -f $file.copy
+       verify_46 $file $file.copy "7. SEL file"
+
+       ########################### 8. SEL dir ##############################
+       echo "  ** 8. SEL dir"
+       $LFS setstripe -E256M -S 1M -c2 -z 64M -E-1 -z 128M \
+               $dir || error "setstripe $dir failed"
+
+       verify_46 $dir $dir.copy "8. SEL dir"
+
+       ########################### 9. FLR SEL file ##########################
+       echo "  ** 9. FLR SEL file"
+       rm -f $file
+       $LFS setstripe -N -E256M -c2 -z 64M -E-1 -z 128M \
+               -N -E1G -c4 -z128M -E-1 -z256M $file || error "Create $file failed"
+
+       rm -f $file.copy
+       verify_46 $file $file.copy "9. SEL file"
+
+       ########################### 10. FLR SEL dir #########################
+       echo "  ** 10. FLR SEL dir"
+       $LFS setstripe -N -E256M -c2 -z 64M -E-1 -z 128M \
+               -N -E1G -c4 -z128M -E-1 -z256M $dir || error "Create $file failed"
+
+       verify_46 $dir $dir.copy "10. SEL dir"
 }
 run_test 46 "Verify setstripe --copy option"
 
@@ -1981,6 +2202,9 @@ test_47() {
 run_test 47 "Verify mirror obj alloc"
 
 test_48() {
+       [ $MDS1_VERSION -lt $(version_code 2.11.55) ] &&
+               skip "Need MDS version at least 2.11.55"
+
        local tf=$DIR/$tfile
 
        rm -f $tf
@@ -2041,6 +2265,92 @@ test_48() {
 }
 run_test 48 "Verify snapshot mirror"
 
+OLDIFS="$IFS"
+cleanup_49() {
+       trap 0
+       IFS="$OLDIFS"
+}
+
+test_49a() {
+       [ "$OSTCOUNT" -lt "2" ] && skip_env "needs >= 2 OSTs"
+
+       trap cleanup_49 EXIT RETURN
+
+       local file=$DIR/$tfile
+
+       $LFS setstripe -N -E eof -c1 -o1 -N -E eof -c1 -o0 $file ||
+               error "setstripe on $file"
+
+       dd if=/dev/zero of=$file bs=1M count=1 || error "dd failed for $file"
+       $LFS mirror resync $file
+
+       filefrag -ves $file || error "filefrag $file failed"
+       filefrag_op=$(filefrag -ve -k $file |
+                     sed -n '/ext:/,/found/{/ext:/d; /found/d; p}')
+
+#Filesystem type is: bd00bd0
+#File size of /mnt/lustre/f49a.sanity-flr is 1048576 (1024 blocks of 1024 bytes)
+# ext:     device_logical:        physical_offset: length:  dev: flags:
+#   0:        0..    1023:    1572864..   1573887:   1024: 0001: net,eof
+#   1:        0..    1023:    1572864..   1573887:   1024: 0000: last,net,eof
+#/mnt/lustre/f49a.sanity-flr: 2 extents found
+
+       last_lun=$(echo $filefrag_op | cut -d: -f5)
+       IFS=$'\n'
+       tot_len=0
+       num_luns=1
+       for line in $filefrag_op; do
+               frag_lun=$(echo $line | cut -d: -f5)
+               ext_len=$(echo $line | cut -d: -f4)
+               if [[ "$frag_lun" != "$last_lun" ]]; then
+                       if (( tot_len != 1024 )); then
+                               cleanup_49
+                               error "$file: OST$last_lun $tot_len != 1024"
+                       else
+                               (( num_luns += 1 ))
+                               tot_len=0
+                       fi
+               fi
+               (( tot_len += ext_len ))
+               last_lun=$frag_lun
+       done
+       if (( num_luns != 2 || tot_len != 1024 )); then
+               cleanup_49
+               error "$file: $num_luns != 2, $tot_len != 1024 on OST$last_lun"
+       fi
+
+       echo "FIEMAP on $file succeeded"
+}
+run_test 49a "FIEMAP upon FLR file"
+
+test_50() {    # EX-2179
+       mkdir -p $DIR/$tdir
+
+       local file=$DIR/$tdir/$tfile
+
+       $LFS setstripe -c1 -i0 $file || error "setstripe $file failed"
+
+       $LFS mirror extend -N -c1 -i1 $file ||
+               error "extending mirror for $file failed"
+
+       local olv=$($LFS getstripe $file | awk '/lcm_layout_gen/{print $2}')
+
+       fail mds1
+
+       $LFS mirror split -d --mirror-id=1 $file || error "split $file failed"
+
+       local flv=$($LFS getstripe $file | awk '/lcm_layout_gen/{print $2}')
+
+       echo "$file layout generation from $olv to $flv"
+       (( $flv != ($olv + 1) )) &&
+               error "split does not increase layout gen from $olv to $flv"
+
+       dd if=/dev/zero of=$file bs=1M count=1 || error "write $file failed"
+
+       $LFS getstripe -v $file || error "getstripe $file failed"
+}
+run_test 50 "mirror split update layout generation"
+
 ctrl_file=$(mktemp /tmp/CTRL.XXXXXX)
 lock_file=$(mktemp /var/lock/FLR.XXXXXX)
 
@@ -2254,14 +2564,16 @@ test_202() {
 run_test 202 "lfs setstripe --add-component wide striping"
 
 test_203() {
-       [[ $OSTCOUNT -lt 2 ]] && skip "need >= 2 OSTs" && return
+       [ $MDS1_VERSION -lt $(version_code 2.11.55) ] &&
+               skip "Need MDS version at least 2.11.55"
+       [[ $OSTCOUNT -lt 2 ]] && skip "need >= 2 OSTs"
 
        local tf=$DIR/$tfile
 
        #create 2 mirrors
        $LFS mirror create -N2 -c1 $tf || error "create FLR file $tf"
        #delete first mirror
-       $LFS mirror split --mirror-id=1 -d $tf || error "delete first mirror"
+       $LFS mirror delete --mirror-id=1 $tf || error "delete first mirror"
 
        $LFS getstripe $tf
        local old_id=$($LFS getstripe --mirror-id=2 -I $tf)
@@ -2286,6 +2598,423 @@ test_203() {
 }
 run_test 203 "mirror file preserve mirror ID"
 
+# Simple test of FLR + self-extending layout, SEL in non-primary mirror
+test_204a() {
+       [ "$MDS1_VERSION" -lt $(version_code $SEL_VER) ] &&
+               skip "skipped for lustre < $SEL_VER"
+
+       local comp_file=$DIR/$tdir/$tfile
+       local flg_opts=""
+       local found=""
+
+       test_mkdir $DIR/$tdir
+
+       # first mirror is 0-10M, then 10M-(-1), second mirror is 1M followed
+       # by extension space to -1
+       $LFS setstripe -N -E 10M -E-1 -N -E 1M -E-1 -z64M $comp_file ||
+               error "Create $comp_file failed"
+
+       # Write to first component, extending & staling second mirror
+       dd if=/dev/zero bs=2M count=1 of=$comp_file conv=notrunc ||
+               error "dd to extend + stale failed"
+
+       $LFS getstripe $comp_file
+
+       flg_opts="--component-flags init,stale"
+       found=$($LFS find --component-end 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: Second comp end incorrect"
+
+       flg_opts="--component-flags extension"
+       found=$($LFS find --component-start 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: Third comp start incorrect"
+
+       # mirror resync should not change the extents
+       $LFS mirror resync $comp_file
+
+       flg_opts="--component-flags init"
+       found=$($LFS find --component-end 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: Second comp end incorrect"
+
+       flg_opts="--component-flags extension"
+       found=$($LFS find --component-start 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: Third comp start incorrect"
+
+       sel_layout_sanity $comp_file 5
+
+       rm -f $comp_file
+}
+run_test 204a "FLR write/stale/resync tests with self-extending mirror"
+
+# Simple test of FLR + self-extending layout, SEL in primary mirror
+test_204b() {
+       [ "$MDS1_VERSION" -lt $(version_code $SEL_VER) ] &&
+               skip "skipped for lustre < $SEL_VER"
+
+       local comp_file=$DIR/$tdir/$tfile
+       local flg_opts=""
+       local found=""
+
+       test_mkdir $DIR/$tdir
+
+       # first mirror is 1M followed by extension space to -1, second mirror
+       # is 0-10M, then 10M-(-1),
+       $LFS setstripe -N -E 1M -E-1 -z64M -N -E 10M -E-1 $comp_file ||
+               error "Create $comp_file failed"
+
+       # Write to first component, extending first component & staling
+       # other mirror
+       dd if=/dev/zero bs=2M count=1 of=$comp_file conv=notrunc ||
+               error "dd to extend + stale failed"
+
+       $LFS getstripe $comp_file
+
+       flg_opts="--component-flags init"
+       found=$($LFS find --component-end 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: First comp end incorrect"
+
+       flg_opts="--component-flags extension"
+       found=$($LFS find --component-start 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: Second comp start incorrect"
+
+       flg_opts="--component-flags init,stale"
+       found=$($LFS find --component-end 10M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: First mirror comp flags incorrect"
+
+       # This component is staled because it overlaps the extended first
+       # component of the primary mirror, even though it doesn't overlap
+       # the actual write - thus not inited.
+       flg_opts="--component-flags stale"
+       found=$($LFS find --component-start 10M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: Second mirror comp flags incorrect"
+
+       # mirror resync should not change the extents
+       $LFS mirror resync $comp_file
+
+       $LFS getstripe $comp_file
+
+       flg_opts="--component-flags init"
+       found=$($LFS find --component-end 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: First comp end incorrect"
+
+       flg_opts="--component-flags extension"
+       found=$($LFS find --component-start 65M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: Second comp start incorrect"
+
+       flg_opts="--component-flags init"
+       found=$($LFS find --component-end 10M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: First mirror comp flags incorrect"
+
+       flg_opts="--component-flags init"
+       found=$($LFS find --component-start 10M $flg_opts $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: Second mirror comp flags incorrect"
+
+       sel_layout_sanity $comp_file 5
+
+       rm -f $comp_file
+}
+run_test 204b "FLR write/stale/resync tests with self-extending primary"
+
+# FLR + SEL failed extension & component removal
+# extension space in second mirror
+test_204c() {
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs"
+       [ "$MDS1_VERSION" -lt $(version_code $SEL_VER) ] &&
+               skip "skipped for lustre < $SEL_VER"
+
+       local comp_file=$DIR/$tdir/$tfile
+       local found=""
+       local ost_idx1=0
+       local ost_name=$(ostname_from_index $ost_idx1)
+
+       test_mkdir $DIR/$tdir
+
+       # first mirror is is 0-10M, then 10M-(-1), second mirror is 0-1M, then
+       # extension space from 1M to 1G, then normal space to -1
+       $LFS setstripe -N -E 10M -E-1 -N -E 1M -E 1G -i $ost_idx1 -z 64M \
+               -E -1 $comp_file || error "Create $comp_file failed"
+
+       do_facet ost1 $LCTL set_param -n obdfilter.$ost_name.degraded=1
+       sleep_maxage
+
+       # write to first comp (0 - 10M) of mirror 1, extending + staling
+       # first + second comp of mirror 2
+       dd if=/dev/zero bs=2M count=1 of=$comp_file conv=notrunc
+       RC=$?
+
+       do_facet ost1 $LCTL set_param -n obdfilter.$ost_name.degraded=0
+       sleep_maxage
+
+       [ $RC -eq 0 ] || error "dd to extend + stale failed"
+
+       $LFS getstripe $comp_file
+
+       found=$($LFS find --component-start 0m --component-end 1m \
+               --comp-flags init,stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: First mirror comp incorrect"
+
+       found=$($LFS find --component-start 1m --component-end EOF \
+               --comp-flags stale,^init $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: Second mirror comp incorrect"
+
+       local mirror_id=$($LFS getstripe --component-start=1m   \
+                        --component-end=EOF $comp_file |       \
+                        grep lcme_mirror_id | awk '{ print $2 }')
+
+       [[ $mirror_id -eq 2 ]] ||
+               error "component not in correct mirror? $mirror_id"
+
+       $LFS mirror resync $comp_file
+
+       $LFS getstripe $comp_file
+
+       # component dimensions should not change from resync
+       found=$($LFS find --component-start 1m --component-end EOF \
+               --component-flags init $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: Second mirror comp incorrect"
+
+       sel_layout_sanity $comp_file 4
+
+       rm -f $comp_file
+}
+run_test 204c "FLR write/stale/resync test with component removal"
+
+# Successful repeated component in primary mirror
+test_204d() {
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs"
+       [ "$MDS1_VERSION" -lt $(version_code $SEL_VER) ] &&
+               skip "skipped for lustre < $SEL_VER"
+
+       local comp_file=$DIR/$tdir/$tfile
+       local found=""
+
+       wait_delete_completed
+       wait_mds_ost_sync
+       test_mkdir $DIR/$tdir
+
+       # first mirror is 64M followed by extension space to -1, second mirror
+       # is 0-10M, then 10M-(-1)
+       $LFS setstripe -N -E-1 -z64M -N -E 10M -E-1 $comp_file ||
+               error "Create $comp_file failed"
+
+       local ost_idx1=$($LFS getstripe -I65537 -i $comp_file)
+       local ost_name=$(ostname_from_index $ost_idx1)
+       # degrade OST for first comp so we won't extend there
+       do_facet ost$((ost_idx1+1)) $LCTL set_param -n \
+               obdfilter.$ost_name.degraded=1
+       sleep_maxage
+
+       # Write beyond first component, causing repeat & stale second mirror
+       dd if=/dev/zero bs=1M count=1 seek=66 of=$comp_file conv=notrunc
+       RC=$?
+
+       do_facet ost$((ost_idx1+1)) $LCTL set_param -n \
+               obdfilter.$ost_name.degraded=0
+       sleep_maxage
+
+       [ $RC -eq 0 ] || error "dd to repeat & stale failed"
+
+       $LFS getstripe $comp_file
+
+       found=$($LFS find --component-start 64m --component-end 128m \
+               --component-flags init $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: Repeat comp incorrect"
+
+       local ost_idx2=$($LFS getstripe --component-start=64m           \
+                        --component-end=128m --component-flags=init    \
+                        -i $comp_file)
+       [[ $ost_idx1 -eq $ost_idx2 ]] && error "$ost_idx1 == $ost_idx2"
+       local mirror_id=$($LFS getstripe --component-start=64m          \
+                        --component-end=128m --component-flags=init    \
+                        $comp_file | grep lcme_mirror_id | awk '{ print $2 }')
+       [[ $mirror_id -eq 1 ]] ||
+               error "component not in correct mirror: $mirror_id, not 1"
+
+       $LFS mirror resync $comp_file
+
+       $LFS getstripe $comp_file
+
+       # component dimensions should not change from resync
+       found=$($LFS find --component-start 0m --component-end 64m \
+               --component-flags init $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: first comp incorrect"
+       found=$($LFS find --component-start 64m --component-end 128m \
+               --component-flags init $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: repeat comp incorrect"
+
+       sel_layout_sanity $comp_file 5
+
+       rm -f $comp_file
+}
+run_test 204d "FLR write/stale/resync sel test with repeated comp"
+
+# Successful repeated component, SEL in non-primary mirror
+test_204e() {
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs"
+       [ "$MDS1_VERSION" -lt $(version_code $SEL_VER) ] &&
+               skip "skipped for lustre < $SEL_VER"
+
+       local comp_file=$DIR/$tdir/$tfile
+       local found=""
+
+       wait_delete_completed
+       wait_mds_ost_sync
+
+       test_mkdir $DIR/$tdir
+
+       # first mirror is is 0-100M, then 100M-(-1), second mirror is extension
+       # space to -1 (-z 64M, so first comp is 0-64M)
+       # Note: we have to place both 1st components on OST0, otherwise 2 OSTs
+       # will be not enough - one will be degraded, the other is used on
+       # an overlapping mirror.
+       $LFS setstripe -N -E 100M -i 0 -E-1 -N -E-1 -i 0 -z 64M $comp_file ||
+               error "Create $comp_file failed"
+
+       local ost_idx1=$($LFS getstripe --component-start=0 \
+                        --component-end=64m -i $comp_file)
+       local ost_name=$(ostname_from_index $ost_idx1)
+       # degrade OST for first comp of 2nd mirror so we won't extend there
+       do_facet ost$((ost_idx1+1)) $LCTL set_param -n \
+               obdfilter.$ost_name.degraded=1
+       sleep_maxage
+
+       $LFS getstripe $comp_file
+
+       # Write to first component, stale & instantiate second mirror components
+       # overlapping with the written component (0-100M);
+       dd if=/dev/zero bs=2M count=1 of=$comp_file conv=notrunc
+       RC=$?
+
+       do_facet ost$((ost_idx1+1)) $LCTL set_param -n \
+               obdfilter.$ost_name.degraded=0
+       sleep_maxage
+       $LFS getstripe $comp_file
+
+       [ $RC -eq 0 ] || error "dd to repeat & stale failed"
+
+       found=$($LFS find --component-start 0m --component-end 64m \
+               --component-flags init,stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: first comp incorrect"
+
+       # was repeated due to degraded ost
+       found=$($LFS find --component-start 64m --component-end 128m \
+               --component-flags init,stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: repeated comp incorrect"
+
+       local ost_idx2=$($LFS getstripe --component-start=64m           \
+                        --component-end=128m --component-flags=init    \
+                        -i $comp_file)
+       [[ $ost_idx1 -eq $ost_idx2 ]] && error "$ost_idx1 == $ost_idx2"
+       local mirror_id=$($LFS getstripe --component-start=0m           \
+                        --component-end=64m --component-flags=init     \
+                        $comp_file | grep lcme_mirror_id | awk '{ print $2 }')
+       [[ $mirror_id -eq 2 ]] ||
+               error "component not in correct mirror? $mirror_id"
+
+       $LFS mirror resync $comp_file
+
+       $LFS getstripe $comp_file
+
+       # component dimensions should not change from resync
+       found=$($LFS find --component-start 0m --component-end 64m \
+               --component-flags init,^stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: first comp incorrect"
+       found=$($LFS find --component-start 64m --component-end 128m \
+               --component-flags init,^stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: repeated comp incorrect"
+
+       sel_layout_sanity $comp_file 5
+
+       rm -f $comp_file
+}
+run_test 204e "FLR write/stale/resync sel test with repeated comp"
+
+# FLR + SEL: failed repeated component, SEL in non-primary mirror
+test_204f() {
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs"
+       [ "$MDS1_VERSION" -lt $(version_code $SEL_VER) ] &&
+               skip "skipped for lustre < $SEL_VER"
+
+       local comp_file=$DIR/$tdir/$tfile
+       local found=""
+
+       wait_delete_completed
+       wait_mds_ost_sync
+       test_mkdir $DIR/$tdir
+
+       pool_add $TESTNAME || error "Pool creation failed"
+       pool_add_targets $TESTNAME 0 1 || error "Pool add targets failed"
+
+       # first mirror is is 0-100M, then 100M-(-1), second mirror is extension
+       # space to -1 (-z 64M, so first comp is 0-64M)
+       $LFS setstripe -N -E 100M -E-1 -N --pool="$TESTNAME" \
+               -E-1 -c 1 -z 64M $comp_file || error "Create $comp_file failed"
+
+       local ost_name0=$(ostname_from_index 0)
+       local ost_name1=$(ostname_from_index 1)
+
+       # degrade both OSTs in pool, so we'll try to repeat, then fail and
+       # extend original comp
+       do_facet ost1 $LCTL set_param -n obdfilter.$ost_name0.degraded=1
+       do_facet ost2 $LCTL set_param -n obdfilter.$ost_name1.degraded=1
+       sleep_maxage
+
+       # a write to the 1st component, 100M length, which will try to stale
+       # the first 100M of mirror 2, attempting to extend its 0-64M component
+       dd if=/dev/zero bs=2M count=1 of=$comp_file conv=notrunc
+       RC=$?
+
+       do_facet ost1 $LCTL set_param -n obdfilter.$ost_name0.degraded=0
+       do_facet ost2 $LCTL set_param -n obdfilter.$ost_name1.degraded=0
+       sleep_maxage
+
+       [ $RC -eq 0 ] || error "dd to extend mirror comp failed"
+
+       $LFS getstripe $comp_file
+
+       found=$($LFS find --component-start 0m --component-end 128m \
+               --component-flags init,stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "write: First mirror comp incorrect"
+
+       local mirror_id=$($LFS getstripe --component-start=0m           \
+                        --component-end=128m --component-flags=init    \
+                        $comp_file | grep lcme_mirror_id | awk '{ print $2 }')
+
+       [[ $mirror_id -eq 2 ]] ||
+               error "component not in correct mirror? $mirror_id, not 2"
+
+       $LFS mirror resync $comp_file
+
+       $LFS getstripe $comp_file
+
+       # component dimensions should not change from resync
+       found=$($LFS find --component-start 0m --component-end 128m \
+               --component-flags init,^stale $comp_file | wc -l)
+       [ $found -eq 1 ] || error "resync: First mirror comp incorrect"
+
+       sel_layout_sanity $comp_file 4
+
+       rm -f $comp_file
+}
+run_test 204f "FLR write/stale/resync sel w/forced extension"
+
+function test_205() {
+       local tf=$DIR/$tfile
+       local mirrors
+
+       $LFS setstripe -c1 $tf
+       $LFS mirror extend -N $tf
+       mirrors=$($LFS getstripe $tf | grep lcme_mirror_id | wc -l )
+       (( $mirrors == 2 )) || error "no new mirror was created?"
+
+       $LFS mirror extend -N --flags=prefer $tf
+       mirrors=$($LFS getstripe $tf | grep lcme_mirror_id | wc -l )
+       (( $mirrors == 3 )) || error "no new mirror was created?"
+
+       $($LFS getstripe $tf | grep lcme_flags: | tail -1 | grep -q prefer) ||
+               error "prefer flag was not set on the new mirror"
+}
+run_test 205 "lfs mirror extend to set prefer flag"
+
 complete $SECONDS
 check_and_cleanup_lustre
 exit_status